package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetMetaCollectionDetail invokes the dataworks_public.GetMetaCollectionDetail API synchronously
func (client *Client) GetMetaCollectionDetail(request *GetMetaCollectionDetailRequest) (response *GetMetaCollectionDetailResponse, err error) {
	response = CreateGetMetaCollectionDetailResponse()
	err = client.DoAction(request, response)
	return
}

// GetMetaCollectionDetailWithChan invokes the dataworks_public.GetMetaCollectionDetail API asynchronously
func (client *Client) GetMetaCollectionDetailWithChan(request *GetMetaCollectionDetailRequest) (<-chan *GetMetaCollectionDetailResponse, <-chan error) {
	responseChan := make(chan *GetMetaCollectionDetailResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetMetaCollectionDetail(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetMetaCollectionDetailWithCallback invokes the dataworks_public.GetMetaCollectionDetail API asynchronously
func (client *Client) GetMetaCollectionDetailWithCallback(request *GetMetaCollectionDetailRequest, callback func(response *GetMetaCollectionDetailResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetMetaCollectionDetailResponse
		var err error
		defer close(result)
		response, err = client.GetMetaCollectionDetail(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetMetaCollectionDetailRequest is the request struct for api GetMetaCollectionDetail
type GetMetaCollectionDetailRequest struct {
	*requests.RpcRequest
	QualifiedName string `position:"Query" name:"QualifiedName"`
}

// GetMetaCollectionDetailResponse is the response struct for api GetMetaCollectionDetail
type GetMetaCollectionDetailResponse struct {
	*responses.BaseResponse
}

// CreateGetMetaCollectionDetailRequest creates a request to invoke GetMetaCollectionDetail API
func CreateGetMetaCollectionDetailRequest() (request *GetMetaCollectionDetailRequest) {
	request = &GetMetaCollectionDetailRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "GetMetaCollectionDetail", "", "")
	request.Method = requests.POST
	return
}

// CreateGetMetaCollectionDetailResponse creates a response to parse from GetMetaCollectionDetail response
func CreateGetMetaCollectionDetailResponse() (response *GetMetaCollectionDetailResponse) {
	response = &GetMetaCollectionDetailResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
