package ecd

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateFotaTask invokes the ecd.UpdateFotaTask API synchronously
func (client *Client) UpdateFotaTask(request *UpdateFotaTaskRequest) (response *UpdateFotaTaskResponse, err error) {
	response = CreateUpdateFotaTaskResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateFotaTaskWithChan invokes the ecd.UpdateFotaTask API asynchronously
func (client *Client) UpdateFotaTaskWithChan(request *UpdateFotaTaskRequest) (<-chan *UpdateFotaTaskResponse, <-chan error) {
	responseChan := make(chan *UpdateFotaTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateFotaTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateFotaTaskWithCallback invokes the ecd.UpdateFotaTask API asynchronously
func (client *Client) UpdateFotaTaskWithCallback(request *UpdateFotaTaskRequest, callback func(response *UpdateFotaTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateFotaTaskResponse
		var err error
		defer close(result)
		response, err = client.UpdateFotaTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateFotaTaskRequest is the request struct for api UpdateFotaTask
type UpdateFotaTaskRequest struct {
	*requests.RpcRequest
	UserStatus string `position:"Query" name:"UserStatus"`
	TaskUid    string `position:"Query" name:"TaskUid"`
}

// UpdateFotaTaskResponse is the response struct for api UpdateFotaTask
type UpdateFotaTaskResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUpdateFotaTaskRequest creates a request to invoke UpdateFotaTask API
func CreateUpdateFotaTaskRequest() (request *UpdateFotaTaskRequest) {
	request = &UpdateFotaTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ecd", "2020-09-30", "UpdateFotaTask", "", "")
	request.Method = requests.POST
	return
}

// CreateUpdateFotaTaskResponse creates a response to parse from UpdateFotaTask response
func CreateUpdateFotaTaskResponse() (response *UpdateFotaTaskResponse) {
	response = &UpdateFotaTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
