package eflo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AssignLeniPrivateIpAddress invokes the eflo.AssignLeniPrivateIpAddress API synchronously
func (client *Client) AssignLeniPrivateIpAddress(request *AssignLeniPrivateIpAddressRequest) (response *AssignLeniPrivateIpAddressResponse, err error) {
	response = CreateAssignLeniPrivateIpAddressResponse()
	err = client.DoAction(request, response)
	return
}

// AssignLeniPrivateIpAddressWithChan invokes the eflo.AssignLeniPrivateIpAddress API asynchronously
func (client *Client) AssignLeniPrivateIpAddressWithChan(request *AssignLeniPrivateIpAddressRequest) (<-chan *AssignLeniPrivateIpAddressResponse, <-chan error) {
	responseChan := make(chan *AssignLeniPrivateIpAddressResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AssignLeniPrivateIpAddress(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AssignLeniPrivateIpAddressWithCallback invokes the eflo.AssignLeniPrivateIpAddress API asynchronously
func (client *Client) AssignLeniPrivateIpAddressWithCallback(request *AssignLeniPrivateIpAddressRequest, callback func(response *AssignLeniPrivateIpAddressResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AssignLeniPrivateIpAddressResponse
		var err error
		defer close(result)
		response, err = client.AssignLeniPrivateIpAddress(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AssignLeniPrivateIpAddressRequest is the request struct for api AssignLeniPrivateIpAddress
type AssignLeniPrivateIpAddressRequest struct {
	*requests.RpcRequest
	ClientToken               string `position:"Body" name:"ClientToken"`
	Description               string `position:"Body" name:"Description"`
	PrivateIpAddress          string `position:"Body" name:"PrivateIpAddress"`
	ElasticNetworkInterfaceId string `position:"Body" name:"ElasticNetworkInterfaceId"`
}

// AssignLeniPrivateIpAddressResponse is the response struct for api AssignLeniPrivateIpAddress
type AssignLeniPrivateIpAddressResponse struct {
	*responses.BaseResponse
	Code      int     `json:"Code" xml:"Code"`
	Message   string  `json:"Message" xml:"Message"`
	RequestId string  `json:"RequestId" xml:"RequestId"`
	Content   Content `json:"Content" xml:"Content"`
}

// CreateAssignLeniPrivateIpAddressRequest creates a request to invoke AssignLeniPrivateIpAddress API
func CreateAssignLeniPrivateIpAddressRequest() (request *AssignLeniPrivateIpAddressRequest) {
	request = &AssignLeniPrivateIpAddressRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("eflo", "2022-05-30", "AssignLeniPrivateIpAddress", "eflo", "openAPI")
	request.Method = requests.POST
	return
}

// CreateAssignLeniPrivateIpAddressResponse creates a response to parse from AssignLeniPrivateIpAddress response
func CreateAssignLeniPrivateIpAddressResponse() (response *AssignLeniPrivateIpAddressResponse) {
	response = &AssignLeniPrivateIpAddressResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
