package ens

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RestartWorkflow invokes the ens.RestartWorkflow API synchronously
func (client *Client) RestartWorkflow(request *RestartWorkflowRequest) (response *RestartWorkflowResponse, err error) {
	response = CreateRestartWorkflowResponse()
	err = client.DoAction(request, response)
	return
}

// RestartWorkflowWithChan invokes the ens.RestartWorkflow API asynchronously
func (client *Client) RestartWorkflowWithChan(request *RestartWorkflowRequest) (<-chan *RestartWorkflowResponse, <-chan error) {
	responseChan := make(chan *RestartWorkflowResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RestartWorkflow(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RestartWorkflowWithCallback invokes the ens.RestartWorkflow API asynchronously
func (client *Client) RestartWorkflowWithCallback(request *RestartWorkflowRequest, callback func(response *RestartWorkflowResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RestartWorkflowResponse
		var err error
		defer close(result)
		response, err = client.RestartWorkflow(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RestartWorkflowRequest is the request struct for api RestartWorkflow
type RestartWorkflowRequest struct {
	*requests.RpcRequest
	WorkflowIds *[]string `position:"Query" name:"WorkflowIds"  type:"Json"`
}

// RestartWorkflowResponse is the response struct for api RestartWorkflow
type RestartWorkflowResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateRestartWorkflowRequest creates a request to invoke RestartWorkflow API
func CreateRestartWorkflowRequest() (request *RestartWorkflowRequest) {
	request = &RestartWorkflowRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ens", "2017-11-10", "RestartWorkflow", "ens", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRestartWorkflowResponse creates a response to parse from RestartWorkflow response
func CreateRestartWorkflowResponse() (response *RestartWorkflowResponse) {
	response = &RestartWorkflowResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
